/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.laparola.visualizzatesto;

import java.awt.event.ActionEvent;
import java.io.File;
import javax.swing.AbstractAction;
import javax.swing.event.*;
import net.laparola.core.*;
import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.awt.*;
import org.openide.DialogDisplayer;
import org.openide.modules.InstalledFileLocator;
import org.openide.NotifyDescriptor;
import org.openide.util.*;
import org.openide.windows.TopComponent;

/** This method is called from within the constructor to
 * initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is
 * always regenerated by the Form Editor.
 */
// <editor-fold defaultstate="collapsed" desc="Generated Code">
/**
 * Top component which displays something.
 */
@ConvertAsProperties(dtd = "-//net.laparola//VisTesto//EN",
autostore = false)
@TopComponent.Description(preferredID = "TestoTopComponent",
//iconBase="SET/PATH/TO/ICON/HERE", 
persistenceType = TopComponent.PERSISTENCE_ALWAYS)
@TopComponent.Registration(mode = "editor", openAtStartup = true)
@ActionID(category = "Window", id = "net.laparola.VisTestoTopComponent")
@ActionReference(path = "Menu/Window" /*, position = 333 */)
@TopComponent.OpenActionRegistration(displayName = "#CTL_VisTestoAction",
preferredID = "Testo")
public final class Testo extends TopComponent {

    Testi testi = null;

    public Testo() {
        initComponents();
        setName(NbBundle.getMessage(Testo.class, "CTL_VisTestoTopComponent"));
        setToolTipText(NbBundle.getMessage(Testo.class, "HINT_VisTestoTopComponent"));

        getActionMap().put("RicercaAction", new AbstractAction() {

            @Override
            public void actionPerformed(ActionEvent event) {
                eseguiRicerca();
            }
        });

        DocumentListener documentListener = new DocumentListener() {

            @Override
            public void changedUpdate(DocumentEvent documentEvent) {
            }

            @Override
            public void insertUpdate(DocumentEvent documentEvent) {
                btRicerca.setEnabled(!tbRicerca.getText().equals(""));
            }

            @Override
            public void removeUpdate(DocumentEvent documentEvent) {
                btRicerca.setEnabled(!tbRicerca.getText().equals(""));
            }
        };

        tbRicerca.getDocument().addDocumentListener(documentListener);

        // quando nuova versione del file della Bibbia, metti in NBProjects\LaParola\VisualizzaTesto\release
        testi = Lookup.getDefault().lookup(Testi.class);
        File f = InstalledFileLocator.getDefault().locate(".", "net.laparola.visualizzatesto", false);
        testi.aggiungiTestiDaDirectory(f.getAbsolutePath());
        //testi.aggiungiTestiDaDirectory(new File(".").getAbsolutePath());
        if (testi.nomiVersioni().length == 0) {
            aggiungiTestoAllaFinestra(NbBundle.getMessage(Testo.class, "NessunaVersione"));
            tbRicerca.setEnabled(false);
        } else {
            mostraTesto("gen1");
        }

        setName("Nuova Riveduta");
    }

    // TODO update tracking: http://blogs.oracle.com/rechtacek/entry/how_to_update_netbeans_platform http://wiki.netbeans.org/BrandingUpdaterSplash
    // TODO application icon http://wiki.netbeans.org/DevFaqExecutableIcon
    // TODO salva toolbar button hint
    // TODO installazione http://izpack.org/ ?
    // TODO menu e toolbar da disattivo a attivo giusto, ma non si disattiva di nuovo quando non c'è più testo selezionato
    // TODO per correggere distribution zip file http://henryaonnetbeans.blogspot.com/2010/11/netbean-platform-locale-in-zip-build.html
    // TODO riferimenti non dovrebbero cambiare il cursore (style cursor:xx non funziona). Oppure fa funzionare i link
    private void mostraTesto(String riferimento) {
        aggiungiTestoAllaFinestra(testi.getBrano(riferimento, "Nuova Riveduta"));
    }

    private void aggiungiTestoAllaFinestra(CharSequence testoDaVisualizzare) {
        testoInFinestra.setText("<html><head><style type='text/css'>a {text-decoration: none;color: black;}</style></head><body><p style='margin-top: 0;'>" + testoDaVisualizzare + "</p></body></html>");
        testoInFinestra.setCaretPosition(0);
    }

    public void eseguiRicerca() {
        RicercaPanel myPanel = new RicercaPanel();
        NotifyDescriptor nd = new NotifyDescriptor(
                myPanel, // instance of your panel
                "Ricerca", // title of the dialog
                NotifyDescriptor.OK_CANCEL_OPTION,
                NotifyDescriptor.QUESTION_MESSAGE, // ... of a question type => a question mark icon
                null, // we have specified YES_NO_OPTION => can be null, options specified by Look&Feel,
                NotifyDescriptor.OK_OPTION // default option is "Yes"
                );

        if (DialogDisplayer.getDefault().notify(nd) == NotifyDescriptor.OK_OPTION) {
            CharSequence testoDaVisualizzare = null;
            String[] valori = myPanel.getValori();
            String espressioneDaRicercare = valori[0];
            String branoDaRicercare = valori[1];
            try {
                testoDaVisualizzare = testi.getBrano(testi.ricerca(espressioneDaRicercare, branoDaRicercare, "Nuova Riveduta"), "Nuova Riveduta");
            } catch (RicercaEspressioneVuotaException ex) {
                testoDaVisualizzare = "Espressione da ricercare vuota: per favore digita la parola o frase da ricercare.";
            } catch (RicercaErroreSintassiException ex) {
                testoDaVisualizzare = "Errore di sintassi nel carattere numero " + ex.getMessage() + " dell'espressione da ricercare<br />" + espressioneDaRicercare;
            } catch (RicercaParentesiException ex) {
                testoDaVisualizzare = "Errore nelle parentesi nell'espressione da ricercare.";
            } catch (RicercaParentesiQuadrateException ex) {
                testoDaVisualizzare = "Errore nelle parentesi quadrate nell'espressione da ricercare.";
            }
            aggiungiTestoAllaFinestra(testoDaVisualizzare);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tbRicerca = new javax.swing.JTextField();
        btRicerca = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        testoInFinestra = new javax.swing.JTextPane();

        tbRicerca.setNextFocusableComponent(btRicerca);
        tbRicerca.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tbRicercaActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(btRicerca, org.openide.util.NbBundle.getMessage(Testo.class, "Testo.text")); // NOI18N
        btRicerca.setEnabled(false);
        btRicerca.setName(""); // NOI18N
        btRicerca.setNextFocusableComponent(testoInFinestra);
        btRicerca.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btRicercaActionPerformed(evt);
            }
        });

        testoInFinestra.setContentType("text/html"); // NOI18N
        testoInFinestra.setEditable(false);
        testoInFinestra.setName(""); // NOI18N
        testoInFinestra.setNextFocusableComponent(tbRicerca);
        jScrollPane1.setViewportView(testoInFinestra);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(tbRicerca, javax.swing.GroupLayout.DEFAULT_SIZE, 329, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(btRicerca))
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btRicerca)
                    .addComponent(tbRicerca, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 271, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btRicercaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btRicercaActionPerformed
        mostraTesto(tbRicerca.getText());
    }//GEN-LAST:event_btRicercaActionPerformed

private void tbRicercaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tbRicercaActionPerformed
    btRicercaActionPerformed(evt);
}//GEN-LAST:event_tbRicercaActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btRicerca;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField tbRicerca;
    private javax.swing.JTextPane testoInFinestra;
    // End of variables declaration//GEN-END:variables

    @Override
    public void componentOpened() {
        // add custom code on component opening
    }

    @Override
    public void componentClosed() {
        // add custom code on component closing
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "0.20");
        // store your settings
    }

    void readProperties(java.util.Properties p) {
        String version = p.getProperty("version");
        // read your settings according to their version
    }
}
